package com.retail_store.order_management.model;

import java.time.LocalDate;
import java.time.LocalTime;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;

public class Order {
    private String orderId;
    private LocalDate orderDate;
    private LocalTime localTime;
    private String customerName;
    private String phoneNumber;
    List<OrderedProduct> productsList;

    public Order(String orderId, LocalDate orderDate, LocalTime localTime, String customerName, String phoneNumber, List<OrderedProduct> productsList) {
        this.orderId = orderId;
        this.orderDate = orderDate;
        this.localTime = localTime;
        this.customerName = customerName;
        this.phoneNumber = phoneNumber;
        this.productsList = productsList;
    }

    public String orderIdGenerator() {
        return Arrays.stream(UUID.randomUUID().toString().split("-")).findFirst().get() + "#" + Order.class.getSimpleName();
    }
}
